import { Connect } from '../connect';
import { MessageBuilder } from '../connect/message';
import { CredentialManager } from '../credentialManager';
import { Session } from '../session';
import { User } from '../user';
import { AuthInfo, LoginResult, LogoutResult } from './auth.types';
export interface Auth {
    readonly loggedUserResult: LoginResult;
    readonly isLoggedIn: boolean;
    readonly currentUser: User;
    login(credentials: AuthInfo): Promise<LoginResult>;
    logout(): Promise<LogoutResult>;
    reAuthFromSession(): Promise<boolean>;
}
export declare class DefaultAuth implements Auth {
    private session;
    private connect;
    private messageBuilder;
    private credentialManager;
    isWorking: boolean;
    loggedUserResult: LoginResult;
    currentUser: User;
    get isLoggedIn(): boolean;
    constructor(session: Session, connect: Connect, messageBuilder: MessageBuilder, credentialManager: CredentialManager);
    login(credentials: AuthInfo): Promise<LoginResult>;
    logout(): Promise<LogoutResult>;
    reAuthFromSession(): Promise<boolean>;
    protected ensureConnection(): Promise<boolean>;
    private getLoggedUserFromSession;
    private applyAuthResults;
    private removeAuthResults;
}
export declare const Auth: import("@microsoft/fast-foundation").InterfaceSymbol<Auth>;
//# sourceMappingURL=auth.d.ts.map