import type { FieldMetadata, FilteredDataServerResult, RawDataServerResult } from '../metadata/metadata.types';
export declare enum ResourceType {
    DATASERVER = "DATASERVER",
    EVENT_HANDLER = "EVENT_HANDLER",
    REQUEST_SERVER = "REQUEST_SERVER"
}
export interface DataUpdate {
    add?: Array<any>;
    drop?: Array<any>;
    modify?: Array<any>;
}
export interface Dataview {
    update?: (data: DataUpdate) => Promise<void>;
    data: any[];
    columnsMetadata?: FieldMetadata[];
    hideSearch?: boolean;
}
export interface DatasourceOptions {
    criteria?: string;
    fields?: string;
    isSnapshot?: boolean;
    maxRows?: number;
    maxView?: number;
    orderBy?: string;
    request?: any;
    resourceName?: string;
    reverse?: boolean;
}
export declare class DatasourceDefaults {
    static readonly MAX_ROWS_250 = 250;
    static readonly MAX_VIEW_1000 = 1000;
    static readonly REQ_REP_POLLING_INTERVAL_MS = 10000;
}
export interface DatasourceConfig {
    options: DatasourceOptions;
    criteriaToFields(filters: string): Record<string, string>;
    dataServerResultFilter(result: RawDataServerResult, rowId?: string): FilteredDataServerResult;
}
export declare const DatasourceConfig: import("@microsoft/fast-foundation").InterfaceSymbol<DatasourceConfig>;
//# sourceMappingURL=datasource.types.d.ts.map