import type { DTOMapper } from '@genesislcap/foundation-utils';
import type { SocketSubscription } from '../connect/socket';
import type { FilteredDataServerResult, RowData } from '../metadata/metadata.types';
import { DefaultDatasource } from './datasource';
import type { DatasourceOptions } from './datasource.types';
export interface EntityDatasourceInit<TDTO, TEntity> {
    options: Omit<DatasourceOptions, 'isSnapshot'>;
    mapper: DTOMapper<TDTO, TEntity>;
    fetchMeta?: boolean;
}
export interface EntityDatasource<TDTO, TEntity> {
    readonly initialized: boolean;
    initialize(init: EntityDatasourceInit<TDTO, TEntity>): Promise<boolean>;
    readonly cache: TEntity[];
    readonly isEmpty: boolean;
    disconnect(): void;
}
export declare class DefaultEntityDatasource<TDTO, TEntity> extends DefaultDatasource implements EntityDatasource<TDTO, TEntity> {
    protected mapper: DTOMapper<TDTO, TEntity>;
    protected sourceRef: string;
    protected subscription: SocketSubscription;
    protected subscriptionLoggedOff: boolean;
    protected entityCache: TEntity[];
    protected entityMap: Map<string, TEntity>;
    protected rowId: string;
    initialized: boolean;
    initialize: (init: EntityDatasourceInit<TDTO, TEntity>) => Promise<boolean>;
    get cache(): TEntity[];
    get isEmpty(): boolean;
    disconnect: () => void;
    protected updateCache(result: FilteredDataServerResult): void;
    protected processRowDataUpdate(rowData: RowData[], inserting?: boolean): void;
}
export declare const EntityDatasource: import("@microsoft/fast-foundation").InterfaceSymbol<EntityDatasource<any, any>>;
//# sourceMappingURL=entityDatasource.d.ts.map